﻿local tomYeller = CreateFrame('Frame', 'tomYeller')
_G.tomYeller = tomYeller
tomYeller:SetScript('OnEvent', function(self, event, ...) self[event](self, event, ...) end)
tomYeller:RegisterEvent('PLAYER_ENTERING_WORLD')

local L = {}
if GetLocale() == 'frFR' then
	L.rezCombatStart = '{rt8} >>> Début de %s de %s <<< {rt8}'
	L.rezCombatFailed = '{rt8} <<< Annulation de %s de %s >>> {rt8}'
	L.rezCombatSucceed = '{rt8} !!! %s de %s !!! {rt8}'
	L.raidAuraApplied = '{rt2} +++ Début de %s +++ {rt2}'
	L.raidAuraRemoved = '{rt2} --- Fin de %s --- {rt2}'
	L.targetAuraApplied = '{rt1} +++ Début de %s sur %s +++ {rt1}'
	L.targetAuraRemoved = '{rt1} --- Fin de %s sur %s --- {rt1}'
	L.targetSpellCast = '{rt3} +++ %s sur %s +++ {rt3}'
	L.interrupt = '{rt7} +++ Interruption de %s de %s +++ {rt7}'
	L.lightWell = '{rt5} !!! %s disponible CLICK CLICK (hors GCD et 20m de porté) !!! {rt5}'
	L.configChan = 'Canaux de sortie de tomYeller pour annoncer les interruptions'
	L.configTell = 'Dire'
	L.configParty = 'Groupe'
	L.configRaid = 'Raid'
	L.configPartySwitch = 'Activer les annonces en groupe'
else
	L.rezCombatStart = '{rt8} >>> %s on %s started <<< {rt8}'
	L.rezCombatFailed = '{rt8} <<< %s on %s canceled >>> {rt8}'
	L.rezCombatSucceed = '{rt8} !!! %s on %s !!! {rt8}'
	L.raidAuraApplied = '{rt2} +++ %s started +++ {rt2}'
	L.raidAuraRemoved = '{rt2} --- %s ended --- {rt2}'
	L.targetAuraApplied = '{rt1} +++ %s on %s started +++ {rt1}'
	L.targetAuraRemoved = '{rt1} --- %s on %s ended --- {rt1}'
	L.targetSpellCast = '{rt3} +++ %s on %s +++ {rt3}'
	L.interrupt = '{rt7} +++ %s of %s interrupted +++ {rt7}'
	L.lightWell = '{rt5} !!! %s available CLICK CLICK (out of GCD and range of 20yrd) !!! {rt5}'
	L.configChan = 'tomYeller output channels for interrupts announcements'
	L.configTell = 'Tell'
	L.configParty = 'Party'
	L.configRaid = 'Raid'
	L.configPartySwitch = 'Party announcements for non interrupts annoucements'
end

local CLEU_MAP = {
	SPELL_CAST_START = {
		[20484] = L.rezCombatStart, --Rebirth
		[20707] = L.rezCombatStart, --Soulstone Resurrection
	},
	SPELL_CAST_FAILED = {
		[20484] = L.rezCombatFailed, --Rebirth
		[20707] = L.rezCombatFailed, --Soulstone Resurrection
	},
	SPELL_RESURRECT = {
		[20484] = L.rezCombatSucceed, --Rebirth
		[95750] = L.rezCombatSucceed, --Soulstone Resurrection
		[61999] = L.rezCombatSucceed, --Raise Ally
	},
	SPELL_CAST_SUCCESS = {
		[31821] = L.raidAuraApplied, --Aura Mastery
		[70940] = L.raidAuraApplied, --Divine Guardian
		[97462] = L.raidAuraApplied, --Rallying Cry
		[740]   = L.raidAuraApplied, --Tranquility
		[2825]  = L.raidAuraApplied, -- Bloodlust
		[32182] = L.raidAuraApplied, -- Heroism
		[80353] = L.raidAuraApplied, -- Time Warp
		[90355] = L.raidAuraApplied, -- Ancient Hysteria
		[33206] = L.targetAuraApplied, --Pain Suppression
		[47788] = L.targetAuraApplied, --Guardian Spirit
		[6940]  = L.targetAuraApplied, --Hand of Sacrifice
		[1038]  = L.targetAuraApplied, --Hand of Salvation
		[1022]  = L.targetAuraApplied, --Hand of Protection
		[1044]  = L.targetAuraApplied, --Hand of Freedom
		[29166] = L.targetSpellCast, --Innervate
		[633]   = L.targetSpellCast, --Lay on Hands
		[724]   = L.lightWell, --LightWell
	},
	SPELL_AURA_REMOVED = {
		[31821] = L.raidAuraRemoved, --Aura Mastery
		[740]   = L.raidAuraRemoved, --Tranquility
		[70940] = L.raidAuraRemoved, --Divine Guardian
		[97463] = L.raidAuraRemoved, --Rallying Cry
		[2825]  = L.raidAuraRemoved, -- Bloodlust
		[32182] = L.raidAuraRemoved, -- Heroism
		[80353] = L.raidAuraRemoved, -- Time Warp
		[90355] = L.raidAuraRemoved, -- Ancient Hysteria
		[33206] = L.targetAuraRemoved, --Pain Suppression
		[47788] = L.targetAuraRemoved, --Guardian Spirit
		[6940]  = L.targetAuraRemoved, --Hand of Sacrifice
		[1038]  = L.targetAuraRemoved, --Hand of Salvation
		[1022]  = L.targetAuraRemoved, --Hand of Protection
		[1044]  = L.targetAuraRemoved, --Hand of Freedom
	},
	SPELL_AURA_APPLIED = {
		[70940] = true, --Divine Guardian
		[97463] = true, --Rallying Cry
		[2825]  = true, -- Bloodlust
		[32182] = true, -- Heroism
		[80353] = true, -- Time Warp
		[90355] = true, -- Ancient Hysteria
	},
	SPELL_SUMMON = {
		[98008] = L.raidAuraApplied, --Spirit Link Totem
		[16190] = L.raidAuraApplied, --Mana Tide Totem
		[62618] = L.raidAuraApplied, --Power Word: Barrier
	},
}

local db
function tomYeller:PLAYER_ENTERING_WORLD()
	self.chatDest, self.antiSpam, self.lastAuraApplied, self.summonedGUID = {}, {}, {}, {}
	self.playerGUID = UnitGUID('player')
	self:UnregisterEvent('PLAYER_ENTERING_WORLD')
	if not _G.tomYellerDB then
		_G.tomYellerDB = {['chatSay'] = true, ['chatParty'] = true, ['chatRaid'] = true, ['alertParty'] = true}
	end
	db = _G.tomYellerDB
	local _, playerClass = UnitClass('player')
	if playerClass == 'DRUID' then
		self.combatRezToTrack = GetSpellInfo(20484)
	elseif playerClass == 'WARLOCK' then
		self.combatRezToTrack = GetSpellInfo(20707)
	end
	self:RegisterEvent('PARTY_MEMBERS_CHANGED')
	self:PARTY_MEMBERS_CHANGED()
end

function tomYeller:PARTY_MEMBERS_CHANGED()
	self.chatDest.say = db.chatSay and 'SAY' or nil
	if GetRealNumRaidMembers() > 0 then
		self.chatDest.party, self.chatDest.raid, self.chan = db.chatParty and 'PARTY' or nil, db.chatRaid and 'RAID' or nil, 'RAID'
	elseif GetNumPartyMembers() > 0 then
		self.chatDest.party, self.chatDest.raid, self.chan = db.chatParty and 'PARTY' or nil, nil, db.alertParty and 'PARTY' or nil
	else
		self.chatDest.party, self.chatDest.raid, self.chan = nil, nil, nil
	end
	if not self.activated and (self.chan or next(self.chatDest)) then
		self.activated = true
		if self.chan and self.combatRezToTrack then
			self.uss = true
			self:RegisterEvent('UNIT_SPELLCAST_SENT')
		end
		self:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	elseif self.activated and not self.uss and self.chan and self.combatRezToTrack then
		self.uss = true
		self:RegisterEvent('UNIT_SPELLCAST_SENT')
	elseif self.activated and not (self.chan or next(self.chatDest)) then
		self.activated, self.uss = nil, nil
		self:UnregisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
		self:UnregisterEvent('UNIT_SPELLCAST_SENT')
	end
end

function tomYeller:UNIT_SPELLCAST_SENT(event, unit, spellName, _, targetName)
	if unit == 'player' and self.combatRezToTrack == spellName then
		if targetName == _G.UNKNOWN then
			if UnitIsGhost('target') then
				targetName = UnitName('target')
			elseif UnitIsGhost('mouseover') then
				targetName = UnitName('mouseover')
			end
		end
		self.combatRezTargetName = targetName
	end
end

function tomYeller:AntiSpam(timeStamp, spellId)
	if (not self.lastAuraApplied[spellId] or (timeStamp - self.lastAuraApplied[spellId]) > 1) then
		self.lastAuraApplied[spellId], self.antiSpam[spellId] = timeStamp, 1
	else
		self.antiSpam[spellId] = self.antiSpam[spellId] + 1
	end
end

function tomYeller:COMBAT_LOG_EVENT_UNFILTERED(_, timeStamp, event, _, sourceGUID, _, _, _, targetGUID, targetName, _, _, spellId,_, _, extraSpellId)
	if sourceGUID == self.playerGUID then
		local msg = CLEU_MAP[event] and CLEU_MAP[event][spellId]
		if msg then
			if not self.chan then return end
			local spellLink = GetSpellLink(spellId)
			if event == 'SPELL_SUMMON' then
				self.summonedGUID[spellId == 62618 and 81782 or targetGUID] = spellLink
			elseif event == 'SPELL_AURA_APPLIED' then
				return self:AntiSpam(timeStamp, spellId)
			elseif event == 'SPELL_AURA_REMOVED' and CLEU_MAP.SPELL_AURA_APPLIED[spellId] then
				self.antiSpam[spellId] = self.antiSpam[spellId] - 1
				if self.antiSpam[spellId] ~= 0 then return end
			end
			SendChatMessage(format(msg, spellLink, targetName or self.combatRezTargetName), self.chan)
		elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
			local spellLink = GetSpellLink(extraSpellId)
			local msg = format(L.interrupt, spellLink, targetName)
			for _, dest in pairs(self.chatDest) do
				SendChatMessage(msg, dest)
			end
		end
	elseif self.chan and event == 'SPELL_AURA_APPLIED' and self.summonedGUID[spellId] then
		self:AntiSpam(timeStamp, spellId)
	elseif self.chan and event == 'SPELL_AURA_REMOVED' and self.summonedGUID[spellId] then
		self.antiSpam[spellId] = self.antiSpam[spellId] - 1
		if self.antiSpam[spellId] ~= 0 then return end
		SendChatMessage(format(L.raidAuraRemoved, self.summonedGUID[spellId]), self.chan)
		self.summonedGUID[spellId] = nil
	elseif self.chan and event == 'UNIT_DESTROYED' and self.summonedGUID[targetGUID] then
		SendChatMessage(format(L.raidAuraRemoved, self.summonedGUID[targetGUID]), self.chan)
		self.summonedGUID[targetGUID] = nil
	end
end

---Option Panel
local tomYellerConfig = CreateFrame('Frame', nil, InterfaceOptionsFramePanelContainer)
tomYellerConfig.name = 'tomYeller'
tomYellerConfig:Hide()

function tomYellerConfig:addConfigCheckBox(label, y, dbKey)
	local check = CreateFrame('CheckButton', nil, self)
	check:SetSize(26, 26)
	check:SetPoint('TOPLEFT', self, 'TOPLEFT', 15, y)
	check:SetHitRectInsets(0, -100, 0, 0)
	check:SetNormalTexture([[Interface\Buttons\UI-CheckBox-Up]])
	check:SetPushedTexture([[Interface\Buttons\UI-CheckBox-Down]])
	check:SetHighlightTexture([[Interface\Buttons\UI-CheckBox-Highlight]])
	check:SetCheckedTexture([[Interface\Buttons\UI-CheckBox-Check]])
	local fs = check:CreateFontString(nil, 'ARTWORK', 'GameFontHighlight')
	fs:SetPoint('LEFT', check, 'RIGHT', 0, 1)
	fs:SetText(label)
	check:SetScript('OnClick', function(self)
		db[dbKey] = not db[dbKey]
		tomYeller:PARTY_MEMBERS_CHANGED()
	end)
	check:SetChecked(db[dbKey])
	return check
end

tomYellerConfig:SetScript('OnShow', function(self)
	local title = self:CreateFontString(nil, 'ARTWORK', 'GameFontNormalLarge')
	title:SetPoint('TOPLEFT', 16, -16)
	title:SetText('tomYeller')
	local subtitle = self:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
	subtitle:SetHeight(32)
	subtitle:SetPoint('TOPLEFT', title, 'BOTTOMLEFT', 0, -8)
	subtitle:SetPoint('RIGHT', self, -32, 0)
	subtitle:SetNonSpaceWrap(true)
	subtitle:SetJustifyH('LEFT')
	subtitle:SetJustifyV('TOP')
	subtitle:SetText(L.configChan)
	local sayChat = self:addConfigCheckBox(L.configTell, -50, 'chatSay')
	local groupChat = self:addConfigCheckBox(L.configParty, -75, 'chatParty')
	local raidChat = self:addConfigCheckBox(L.configRaid, -100, 'chatRaid')
	local alertParty = self:addConfigCheckBox(L.configPartySwitch, -125, 'alertParty')
	self:SetScript('OnShow', nil)
end)
InterfaceOptions_AddCategory(tomYellerConfig)